#include <netinet/ip_icmp.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>

#define MAXPACKET	(65536 - 60 - 8)/* max packet size */

char packet[MAXPACKET];

u_short in_cksum(u_short *addr, int len);

int main(int argc, char *argv[])
{
    int s,noreply;
    struct icmp *icp;
    struct hostent *hp;
    struct sockaddr_in whereto; /* gep cime */
    fd_set rset;
    struct timeval timeout;

    if (argc!=2)
    {
	printf("Usage: %s celcim\n",argv[0]);
	exit(1);
    }
	    

    /*socket letrehozasa*/
    s = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
    setuid(getuid());//root jogok eldobsa FONTOS!

    /*ICMP csomag letrehozasa*/
    icp = (struct icmp *)&packet[0];
    icp->icmp_type = ICMP_ECHO;
    icp->icmp_code = 0;
    icp->icmp_cksum = 0;
    icp->icmp_seq = 1;
    icp->icmp_id = getpid();			/* ID */
    strcpy(&packet[8], "HELLO");
    /* checksum kiszamolasa */
    icp->icmp_cksum = in_cksum((u_short *)icp, 64);

    /*cel ip cime*/
    if ((hp = gethostbyname(argv[1])) == 0) 
    {
	herror("gethostbyname");
	exit(2);
    }
    /*cel sockaddr kitoltese*/
    bzero(&whereto, sizeof(whereto));
    bcopy((char *)hp->h_addr, (char *)&whereto.sin_addr, hp->h_length);
    whereto.sin_family = AF_INET;


    /*ICMP csomag elkuldese (64 byte-ot)*/
    if (sendto(s, packet, 64, 0, (struct sockaddr*)&whereto,
	    sizeof(struct sockaddr))<0) exit(1);
    noreply=0;
    while(noreply<3)
    {    
    timeout.tv_usec=0;
    timeout.tv_sec=2;
    FD_ZERO(&rset);
    FD_SET(s, &rset);
    if (select(s+1, &rset, NULL, NULL, &timeout)>0)
    {
	/*valasz beolvasasa*/
	recv(s, &packet[0],  MAXPACKET, 0);
	//A valasz elso resze az IP header, ezt atugorjuk.
	icp=(struct icmp *) &packet[sizeof(struct iphdr)];
	//Ha nem nekunk jott valasz, akkor tovabb
	if (icp->icmp_id!=getpid() || icp->icmp_type!=ICMP_ECHOREPLY) continue;
	printf("Visszajott! Asszem mukodik.\n");
	break;
    }
    else
    {
	/*NEM jott valasz*/
	printf("Nem jott vissza!\n");
	noreply++;
	/*ICMP csomag ujboli elkuldese*/
	sendto(s, packet, 64, 0, (struct sockaddr*)&whereto,
	    sizeof(struct sockaddr));
    }
    }
    close(s);
}

/*
 * in_cksum --
 *	Checksum routine for Internet Protocol family headers (C Version)
 */
u_short
in_cksum(addr, len)
	u_short *addr;
	int len;
{
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	union {
		u_short	us;
		u_char	uc[2];
	} last;
	u_short answer;

	/*
	 * Our algorithm is simple, using a 32 bit accumulator (sum), we add
	 * sequential 16 bit words to it, and at the end, fold back all the
	 * carry bits from the top 16 bits into the lower 16 bits.
	 */
	while (nleft > 1)  {
		sum += *w++;
		nleft -= 2;
	}

	/* mop up an odd byte, if necessary */
	if (nleft == 1) {
		last.uc[0] = *(u_char *)w;
		last.uc[1] = 0;
		sum += last.us;
	}

	/* add back carry outs from top 16 bits to low 16 bits */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return(answer);
}
